/***********************************************************************
*           See Accompanying licence file QSAS_licence                 *
***********************************************************************/

#include "qar.h"


extern "C" QplugReturnStatus QarINVERSE( QplugArgList *);

QplugReturnStatus QarINVERSE  ( QplugArgList *call_list )

{
QplugReturnStatus	status;
int qar_status;


QdObject_var in_ptr;
QdObject_var out_ptr;

char * attr_ptr;
char * string_buf;
char * out_name;

status = QPLUG_SUCCESS;


//	Unpack the input data objects
//
//	..first input item is  Any DO


// get type, number of records and set pointer in object struct

 in_ptr = (*call_list)[0];


// Get name of output object

 char * slot_ptr = GetSlotText(0);
 if ( slot_ptr[0] != '\0' ) {
    out_name = QplugNewSTR(slot_ptr);
 }
 else{
    out_name = QplugNewSTR("Inverse");
    SetSlotText(0,out_name);
 }

// do arithmetic...

out_ptr = invert(in_ptr);

if (out_ptr.is_nil()) {
    QplugAppendTextDisplay (
        "Arithmetic>> Inverse is not available for this input\n");
    return QPLUG_FAILURE; 
}

 // Add timeline if it exists
 
 QdTimeSeq_var tt = get_timetags(in_ptr);
 if (!tt.is_nil()) set_timetags(out_ptr, tt);


 // Set QSAS essential attributes
  
 // FIELDNAM

 attr_ptr = QuGetAttrText("FIELDNAM", in_ptr);
 if( strcmp(attr_ptr, "") != 0){
   string_buf = (char *) malloc(strlen(attr_ptr)+6);
   strcpy(string_buf,"1 / ");
   strcat(string_buf, attr_ptr);
   QuSetTxtAttr("FIELDNAM", string_buf, out_ptr);
   free (string_buf);
 }
 
 
 // Frame

   QuSetTxtAttr("Frame", "scalar>na", out_ptr);
 
 // UNITS
 
 attr_ptr = QuGetAttrText("UNITS", in_ptr);
 if( strcmp(attr_ptr, "") != 0){
   string_buf = (char *) malloc(strlen(attr_ptr)+6);
   strcpy(string_buf,"(");
   strcat(string_buf, attr_ptr);
   strcat(string_buf,")^-1");
   QuSetTxtAttr("UNITS", string_buf, out_ptr);
   free (string_buf);
 }
 
  // SI_conversion
   attr_ptr = QarSIConv_inverse(in_ptr);
   if(attr_ptr != NULL){
     QuSetTxtAttr("SI_conversion", attr_ptr, out_ptr);
     delete[] attr_ptr;
   }


// DEPEND_i etc.
 
// not defined for arrays


  //	..add  the output series to the list

  call_list->push_back(out_ptr);

  QplugAppendTextDisplay ("Inverse: Done\n");
  
return status;

}

