#include "qOperators.h"


QdObject_var QdInvers( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2 )
{

    QdObject_var  qdResult;

    if ( qdOperand1.is_nil() )
    {
        // The object will be empty - this should never happen
		// The qdResult object is NULL at this point
        return ( qdResult );
    }

	char*     attrPtr;
	char*     stringBuf;

	// do arithmetic...
	try
	{
		qdResult = invert( qdOperand1 );
	}
	catch( Exception &e )
	{
		QcalcAppendTextDisplay ( e.msg().c_str() );
		QcalcAppendTextDisplay( "The operation Inverse is not yet supported  for this input type");
		rqstrErrorMsg = QString( "The operation Inverse is not yet supported for this input type");
		return ( qdResult );
	}

	if ( qdResult.is_nil() )
	{
		QcalcAppendTextDisplay( "Arithmetic>> Inverse is not available for this input" );
		rqstrErrorMsg = QString( "Arithmetic>> Inverse is not available for this input" );
		return ( qdResult );
	}

	// Add timeline if it exists
	QdTimeSeq_var qdtt = get_timetags( qdOperand1);
	if ( !qdtt.is_nil() )
	{
		set_timetags( qdResult, qdtt );
	}

	// Set QSAS essential attributes

	// Frame
	QuSetFrame( qdResult, "scalar" );

	// UNITS
	attrPtr = QuGetAttrText( "UNITS", qdOperand1 );
	if ( strcmp( attrPtr, "" ) != 0 )
	{
		stringBuf = ( char * ) malloc( strlen( attrPtr ) + 6 );
		strcpy( stringBuf, "("      );
		strcat( stringBuf, attrPtr  );
		strcat( stringBuf, ")^-1"   );
		QuSetTxtAttr( "UNITS", stringBuf, qdResult );
		free ( stringBuf );
	}
	
	// SI_conversion
	attrPtr = QarSIConv_inverse( qdOperand1 );
	if ( attrPtr != NULL )
	{
		QuSetTxtAttr( "SI_conversion", attrPtr, qdResult );
		delete[] attrPtr;
	}


    return ( qdResult );
}




