#include "qOperators.h"


QdObject_var QdSqrt( QString& rqstrErrorMsg, QdObject_var qdOperand1, QdObject_var qdOperand2  )
{

    QdObject_var  qdResult;

    if ( qdOperand1.is_nil() )
    {
        // The object will be empty - this should never happen
		// The qdResult object is NULL at this point
        return ( qdResult );
    }

	char*  attrPtr       =  NULL;
	char*  stringBuf     =  NULL;

	// do arithmetic...
	try
	{
		qdResult = sqrt( qdOperand1 );
	}
	catch( Exception &e )
	{
		QcalcAppendTextDisplay ( e.msg().c_str() );
		QcalcAppendTextDisplay( "The operation sqrt is not yet supported for the input type");
		rqstrErrorMsg = QString( "The operation sqrt is not yet supported for the input type");
		return ( qdResult );
	}

	if (qdResult.is_nil())
	{
		QcalcAppendTextDisplay( "Arithmetic>> sqrt is not yet supported for the input type" );
		rqstrErrorMsg = QString( "Arithmetic>> sqrt is not yet supported for the input type" );
		return ( qdResult );
	}

	// Add timeline if it exists
	QdTimeSeq_var qdtt = get_timetags( qdOperand1 );
	if (! qdtt.is_nil( ) )
	{
		set_timetags( qdResult, qdtt );
	}

 	// Set QSAS essential attributes

   	// SI_conversion

    // Not meaningfol for a Sqrt whatever the inputs

   	// UNITS

	// Not meaningfol for a sqrt whatever the inputs

 	// Frame
   	QuSetFrame(qdResult, "scalar" );

    return ( qdResult );
}


