/**********************************************************************
* SCCS id: @(#)IndexTSSubset.h	1.1 14:33:12 12/17/98 
***********************************************************************
* PROJECT:   Cluster UK CDHF
* COMPONENT: Time Series Subsetting for Plug-ins
* MODULE:   IndexTSSubset.h header file 
* LANGUAGE:  C  
* PURPOSE:    header file
* DESCRIPTION:  header file
*
* HISTORY: SJ Schwartz and Gareth Chisham, Oct 97
*/

#ifndef INDEXTSSUBSET_H
#define INDEXTSSUBSET_H

static char* IndexTSSubsetErrorMessage[9] = 
   { "IndexTSSubset>> Error zero undefined\n",
     "IndexTSSubset>> Error - no data points in requested interval\n",
     "IndexTSSubset>> Error - input Time Series in descending order\n",
     "IndexTSSubset>> Error - requested start beyond data end time\n",
     "IndexTSSubset>> Error - requested end before data start time\n",
     "IndexTSSubset>> Error - unrecognised negative index for start time\n",
     "IndexTSSubset>> Error - unrecognised negative index for end time\n",
     "IndexTSSubset>> Error - unknown error\n",
     "IndexTSSubset>> Success\n"};

typedef enum IndexTSSubsetErrorStatus_e{
  INDEX_TSSUBSET_ERROR_UNDEFINED,
  INDEX_TSSUBSET_ERROR_NO_DATA,
  INDEX_TSSUBSET_ERROR_DESCENDING,
  INDEX_TSSUBSET_ERROR_START_GT_DATA_END,
  INDEX_TSSUBSET_ERROR_END_LT_DATA_START,
  INDEX_TSSUBSET_ERROR_START_UNDEFINED,
  INDEX_TSSUBSET_ERROR_END_UNDEFINED,
  INDEX_TSSUBSET_ERROR_RETURN,
  INDEX_TSSUBSET_OK
} IndexTSSubsetErrorStatus;

/* Prototypes */

#ifdef __cplusplus
extern "C" {
#endif

/* bi-section to find index to times */

int nle_bisection (double xsearch, double x[], int nx);

IndexTSSubsetErrorStatus IndexTSSubset (
        double tstart,       /* input start and end times for subset interval*/
        double tend, 
        double *in_tags,     /* pointer to input time tags  */
        int ndata,           /* input number of data points */
        int *istart_p,       /* output indices of start and end tags */
        int *iend_p,
        char *out_message
        );

#ifdef __cplusplus
}
#endif

#endif   /* end ifndef INDEXTSSUBSET_H  */


