#include "qie_VOtable.h"


QDOS::QdTimeIntervalSeq_var QiLoadVOTable(QString& fileName)
{
    QFile * myFile=new QFile(fileName);
    if(myFile==NULL) return NULL;
    
    QXmlInputSource source(myFile);
    VOTableParser handler;
    QXmlSimpleReader reader;
    reader.setContentHandler( &handler );
    reader.parse( source );
    
    delete myFile;
    return new QDOS::QdTimeIntervalSeq(handler.table);
}

bool QiSaveVOTable(QDOS::QdTimeIntervalSeq_var& table, QString& fileName)
{
    std::ofstream file(fileName);
    
    if(!file.is_open()) return false;
    
    time_t now;
    time(&now);
    
    file << "<?xml version=\"1.0\"?>" << std::endl;
    file << "<VOTABLE version=\"1.1\"><DESCRIPTION>" << std::endl;
    file << "Table generated by QSAS;" << std::endl;
    file << "Creation Date: " << ctime(&now);
    file << "</DESCRIPTION><RESOURCE><DESCRIPTION>" << std::endl;
    file << "        QSAS" << std::endl;
    file << "</DESCRIPTION><TABLE><FIELD datatype=\"char\" name=\"Start Time\" ID=\"TimeIntervalStart\" ucd=\"time.start\"><DESCRIPTION>time tag for beginning of interval</DESCRIPTION></FIELD><FIELD datatype=\"char\" name=\"Stop Time\" ID=\"TimeIntervalStop\" ucd=\"time.stop\"><DESCRIPTION>time tag for end of interval</DESCRIPTION></FIELD><DATA><TABLEDATA>" << std::endl;
    
    for(int i=0; i<table->sequence_size(); i++)
    {
        file << "<TR><TD>" << table[i].start().iso("T") << "</TD><TD>" << table[i].end().iso("T") << "</TD></TR>" << std::endl;
    }
    
    file << "</TABLEDATA></DATA></TABLE></RESOURCE></VOTABLE>" << std::endl;
    
    file.close();
    
    return true;
}

